Method: users.dataTypes.dataPoints.reconcile

Reconcile data points from multiple data sources into a single data stream.

HTTP request

GET https://health.googleapis.com/v4/{parent=users/*/dataTypes/*}/dataPoints:reconcile

The URL uses gRPC Transcoding syntax. To know more about valid error responses that can be thrown by this HTTP request, please refer to the service error catalog

Path parameters

Parameters
parent

string

Required. Parent data type of the Data Point collection.

Format: users/me/dataTypes/{dataType}, e.g.:

  • users/me/dataTypes/steps
  • users/me/dataTypes/heart-rate

For a list of the supported data types see the DataPoint data union field. It takes the form users/{user}/dataTypes/{datatype}.

Query parameters

Parameters
filter

string

Optional. Filter expression based on https://aip.dev/160.

A time range, either physical or civil, can be specified. See the ListDataPointsRequest.filter for the supported fields and syntax.

pageSize

integer

Optional. The maximum number of data points to return. If unspecified, at most 1440 data points will be returned. The maximum page size is 10000; values above that will be truncated accordingly. For exercise and sleep the default page size is 25. The maximum page size for exercise and sleep is 25.

pageToken

string

Optional. The nextPageToken from a previous request, if any.

dataSourceFamily

string

Optional. The data source family name to reconcile.

If empty, data points from all data sources will be reconciled.

Format: users/me/dataSourceFamilies/{dataSourceFamily}

The supported values are:

  • users/me/dataSourceFamilies/all-sources - default value
  • users/me/dataSourceFamilies/google-wearables - tracker devices
  • users/me/dataSourceFamilies/google-sources - Google first party sources

Request body

The request body must be empty.

Response body

Response containing the list of reconciled DataPoints.

If successful, the response body contains data with the following structure:

JSON representation
{
  "dataPoints": [
    {
      object (ReconciledDataPoint)
    }
  ],
  "nextPageToken": string
}
Fields
dataPoints[]

object (ReconciledDataPoint)

Data points matching the query

nextPageToken

string

Next page token, empty if the response is complete

Authorization scopes

Requires one of the following OAuth scopes:

  • https://www.googleapis.com/auth/googlehealth.activity_and_fitness
  • https://www.googleapis.com/auth/googlehealth.activity_and_fitness.readonly
  • https://www.googleapis.com/auth/googlehealth.health_metrics_and_measurements
  • https://www.googleapis.com/auth/googlehealth.health_metrics_and_measurements.readonly
  • https://www.googleapis.com/auth/googlehealth.location
  • https://www.googleapis.com/auth/googlehealth.location.readonly
  • https://www.googleapis.com/auth/googlehealth.nutrition
  • https://www.googleapis.com/auth/googlehealth.nutrition.readonly
  • https://www.googleapis.com/auth/googlehealth.sleep
  • https://www.googleapis.com/auth/googlehealth.sleep.readonly

For more information, see the OAuth 2.0 Overview.

ReconciledDataPoint

A reconciled computed or recorded metric.

JSON representation
{
  "dataPointName": string,

  // Union field data can be only one of the following:
  "steps": {
    object (Steps)
  },
  "floors": {
    object (Floors)
  },
  "heartRate": {
    object (HeartRate)
  },
  "sleep": {
    object (Sleep)
  },
  "dailyRestingHeartRate": {
    object (DailyRestingHeartRate)
  },
  "dailyHeartRateVariability": {
    object (DailyHeartRateVariability)
  },
  "exercise": {
    object (Exercise)
  },
  "weight": {
    object (Weight)
  },
  "altitude": {
    object (Altitude)
  },
  "distance": {
    object (Distance)
  },
  "bodyFat": {
    object (BodyFat)
  },
  "activeZoneMinutes": {
    object (ActiveZoneMinutes)
  },
  "heartRateVariability": {
    object (HeartRateVariability)
  },
  "dailySleepTemperatureDerivations": {
    object (DailySleepTemperatureDerivations)
  },
  "sedentaryPeriod": {
    object (SedentaryPeriod)
  },
  "runVo2Max": {
    object (RunVO2Max)
  },
  "oxygenSaturation": {
    object (OxygenSaturation)
  },
  "dailyOxygenSaturation": {
    object (DailyOxygenSaturation)
  },
  "activityLevel": {
    object (ActivityLevel)
  },
  "vo2Max": {
    object (VO2Max)
  },
  "dailyVo2Max": {
    object (DailyVO2Max)
  },
  "dailyHeartRateZones": {
    object (DailyHeartRateZones)
  },
  "hydrationLog": {
    object (HydrationLog)
  },
  "timeInHeartRateZone": {
    object (TimeInHeartRateZone)
  },
  "activeMinutes": {
    object (ActiveMinutes)
  },
  "respiratoryRateSleepSummary": {
    object (RespiratoryRateSleepSummary)
  },
  "dailyRespiratoryRate": {
    object (DailyRespiratoryRate)
  }
  // End of list of possible types for union field data.
}
Fields
dataPointName

string

Identifier. Data point name, only supported for the subset of identifiable data types. For the majority of the data types, individual data points do not need to be identified and this field would be empty.

Format: users/{user}/dataTypes/{dataType}/dataPoints/{dataPoint}

Example: users/abcd1234/dataTypes/sleep/dataPoints/a1b2c3d4-e5f6-7890-1234-567890abcdef

The {user} ID is a system-generated identifier, as described in [Profile.encoded_id][google.devicesandservices.health.v4.Profile.encoded_id].

The {dataType} ID corresponds to the kebab-case version of the field names in the DataPoint data union field, e.g. total-calories for the totalCalories field.

The {dataPoint} ID can be client-provided or system-generated. If client-provided, it must be a string of 4-63 characters, containing only lowercase letters, numbers, and hyphens.

Union field data. Data type component in the name field will always correspond to the data field set. These messages represent the data payload for each data type and are embedded within the DataPoint resource. They are not standalone resources themselves. data can be only one of the following:
steps

object (Steps)

Data for points in the steps interval data type collection.

floors

object (Floors)

Data for points in the floors interval data type collection.

heartRate

object (HeartRate)

Data for points in the heart-rate sample data type collection.

sleep

object (Sleep)

Data for points in the sleep session data type collection.

dailyRestingHeartRate

object (DailyRestingHeartRate)

Data for points in the daily-resting-heart-rate daily data type collection.

dailyHeartRateVariability

object (DailyHeartRateVariability)

Data for points in the daily-heart-rate-variability daily data type collection.

exercise

object (Exercise)

Data for points in the exercise session data type collection.

weight

object (Weight)

Data for points in the weight sample data type collection.

altitude

object (Altitude)

Data for points in the altitude interval data type collection.

distance

object (Distance)

Data for points in the distance interval data type collection.

bodyFat

object (BodyFat)

Data for points in the body-fat sample data type collection.

activeZoneMinutes

object (ActiveZoneMinutes)

Data for points in the active-zone-minutes interval data type collection, measured in minutes.

heartRateVariability

object (HeartRateVariability)

Data for points in the heart-rate-variability sample data type collection.

dailySleepTemperatureDerivations

object (DailySleepTemperatureDerivations)

Data for points in the daily-sleep-temperature-derivations daily data type collection.

sedentaryPeriod

object (SedentaryPeriod)

Data for points in the sedentary-period interval data type collection.

runVo2Max

object (RunVO2Max)

Data for points in the run-vo2-max sample data type collection.

oxygenSaturation

object (OxygenSaturation)

Data for points in the oxygen-saturation sample data type collection.

dailyOxygenSaturation

object (DailyOxygenSaturation)

Data for points in the daily-oxygen-saturation daily data type collection.

activityLevel

object (ActivityLevel)

Data for points in the activity-level daily data type collection.

vo2Max

object (VO2Max)

Data for points in the vo2-max sample data type collection.

dailyVo2Max

object (DailyVO2Max)

Data for points in the daily-vo2-max daily data type collection.

dailyHeartRateZones

object (DailyHeartRateZones)

Data for points in the daily-heart-rate-zones daily data type collection.

hydrationLog

object (HydrationLog)

Data for points in the hydration-log session data type collection.

timeInHeartRateZone

object (TimeInHeartRateZone)

Data for points in the time-in-heart-rate-zone interval data type collection.

activeMinutes

object (ActiveMinutes)

Data for points in the active-minutes interval data type collection.

respiratoryRateSleepSummary

object (RespiratoryRateSleepSummary)

Data for points in the respiratory-rate-sleep-summary sample data type collection.

dailyRespiratoryRate

object (DailyRespiratoryRate)

Data for points in the daily-respiratory-rate daily data type collection.